OWNER(g:yatool)

IF(MAPSMOBI_BUILD_TARGET)
    INCLUDE(${ARCADIA_ROOT}/autocheck/mapsmobi_targets.inc)
    PARTITIONED_RECURSE_ROOT_RELATIVE(
        ${AUTOCHECK_MAPSMOBI_TARGETS}
        contrib/libs/harfbuzz
        contrib/libs/woff2
    )
ELSEIF(YANDEXIO_BUILD_TARGET)
    INCLUDE(${ARCADIA_ROOT}/autocheck/linux/yandexio_targets.inc)
    PARTITIONED_RECURSE_ROOT_RELATIVE(${AUTOCHECK_YANDEXIO_TARGETS})
ELSE()
    INCLUDE(${ARCADIA_ROOT}/autocheck/common_targets.inc)

    PARTITIONED_RECURSE_ROOT_RELATIVE(
        ${AUTOCHECK_COMMON_TARGETS}
        catboost/idl
        catboost/libs/cat_feature
        catboost/libs/column_description
        catboost/libs/eval_result
        catboost/libs/gpu_config
        catboost/libs/helpers
        catboost/libs/logging
        catboost/libs/metrics
        catboost/libs/model
        catboost/libs/model_interface
        catboost/libs/overfitting_detector
        catboost/libs/train_lib
        catboost/private/libs/algo
        catboost/private/libs/app_helpers
        catboost/private/libs/ctr_description
        catboost/private/libs/data_types
        catboost/private/libs/data_util
        catboost/private/libs/distributed
        catboost/private/libs/documents_importance
        catboost/private/libs/feature_estimator
        catboost/private/libs/index_range
        catboost/private/libs/labels
        catboost/private/libs/lapack
        catboost/private/libs/options
        catboost/private/libs/pairs
        catboost/private/libs/quantization
        catboost/private/libs/quantization_schema
        catboost/private/libs/quantized_pool
        catboost/private/libs/target
        catboost/private/libs/text_features
        catboost/private/libs/validate_fb
        catboost/python-package/lib
        catboost/tools/model_comparator
        contrib/libs/android_crazy_linker
        contrib/libs/curl
        contrib/libs/libjpeg-turbo
        contrib/libs/libunwind
        contrib/libs/opencv
        contrib/libs/pffft
        contrib/restricted/ashmem
        contrib/restricted/glib
        contrib/restricted/google/xnnpack
        contrib/restricted/gstreamer
        contrib/restricted/gst-plugins-bad
        contrib/restricted/gst-plugins-base
        contrib/restricted/gst-plugins-good
        cv/imageproc/ocr/api/android_lite
        cv/imageproc/ocr/api/text_classifier
        cv/imageproc/ocr/api/mobile_c/dll
        cv/imageproc/ocr/tools/ocr_arm_example
        cv/imgclassifiers/tflite_applicator
        dict/mt/libs/mobile/android
        dict/mt/libs/mobile/android/crazyloader
        keyboard/android/native/jni
        keyboard/android/native/jni/crazyloader
        library/cpp/float16
        quality/trailer/offline_search/android
        search/mobile/android
        speechkit
        voicetech/spotter/embedded/nnet/ynmt
        voicetech/vqe
    )

    IF(NOT ARCH_I686)
        PARTITIONED_RECURSE_ROOT_RELATIVE(
            # Libvpx cannot be build for android-i686 due to dependencies on 64-bit .asm files  
            contrib/libs/libvpx
            # webrtc cannot be build for android-i686 due to dependency on libvpx
            contrib/libs/webrtc
        )
    ENDIF()

    IF(NOT ARCH_I686 AND NOT ARCH_X86_64)
        PARTITIONED_RECURSE_ROOT_RELATIVE(
            # tgcalls cannot be build for android-i686 due to transitive (through webrtc) dependency on libvpx
            # tgcalls cannot be build for android x86_64 due to some problems with libvpx and linker
            contrib/restricted/tgcalls
        )
    ENDIF()
ENDIF()
