OWNER(
    g:yatool
)

IF (OS_DARWIN)
    IF (DARWIN_TOOLS_ONLY)
        RECURSE_ROOT_RELATIVE(
            ads/bsyeti/tools/counter_code_generator
            contrib/libs/apache/apr/tools
            contrib/libs/halide/tools
            contrib/libs/halide/tutorial/lesson_10_aot_compilation_generate
            contrib/libs/hyperscan/runtime/build_mode
            contrib/libs/js-v8/targets/mksnapshot
            contrib/libs/libgraphqlparser/ast
            contrib/libs/libidn2/lib/gendata
            contrib/libs/libidn2/lib/gentr46map
            contrib/libs/libmagic/file/0
            contrib/libs/libmysql_r/strings/uca9dump
            contrib/libs/llvm12/utils/TableGen
            contrib/libs/llvm14/utils/TableGen
            contrib/libs/llvm8/utils/TableGen
            contrib/libs/nodejs_12
            contrib/libs/stan/stan/command
            contrib/python/cffi/gen
            contrib/python/clang/example/parse/parser
            contrib/python/horovod/horovod/tensorflow/gen_mpi_ops/gen
            contrib/python/pystan/pystan_model
            contrib/restricted/openal-soft/native-tools/bin2h
            contrib/restricted/openal-soft/native-tools/bsincgen
            contrib/tools
            dict/gazetteer/compiler
            dict/gazetteer/converter
            dict/tools/make_morphdict/main
            dict/tools/maketransdict
            extsearch/geo/kernel/broto/compiler
            extsearch/geo/tools/proto2mms_codegen
            infra/nanny/httprpc_python
            kernel/factor_slices/slices_codegen
            kernel/fill_factors_codegen
            kernel/sent_lens/generate-trie
            kernel/streams/factors_codegen
            kernel/struct_codegen/codegen_tool
            kernel/text_machine/tm_codegen
            kernel/ugc/schema/compiler/bin
            kernel/vector_machine/codegen
            kernel/web_factors_info/factors_codegen
            ydb/core/grpc_services/validation
            library/cpp/digest/old_crc/gencrc
            library/cpp/proto_config/plugin
            library/cpp/regex/pire/inline
            library/go/core/resource/cc
            maps/libs/sproto/sprotoc
            metrika/core/libs/strconvert/utils
            metrika/core/programs/mobile-startup/data/process_encryption/bin
            metrika/core/tools/python_enum_generator
            metrika/core/tools/render-template
            metrika/core/tools/ssqls
            metrika/mobile-core/devices-names/generate_json
            search/web/core/configuration/conf_json/validator
            security/ant-secret/internal/tools/preserialize-regex
            tasklet/gen/cpp
            tasklet/gen/python
            tools
            vendor/github.com/golang/protobuf/protoc-gen-go
            yql/library/expr_nodes_gen/gen
            yql/tools/udf_probe
        )
    ELSEIF (COMMON_PROJECTS)
        RECURSE_ROOT_RELATIVE(
            # The list of contribs from autocheck/darwin
            contrib/restricted/glib
            contrib/restricted/http-parser
            contrib/restricted/uriparser
            contrib/go
            contrib/libs/ImageMagick
            contrib/libs/apache/arrow
            contrib/libs/backtrace
            contrib/libs/clang12
            contrib/libs/ctemplate
            contrib/libs/fastops
            contrib/libs/fmt
            contrib/libs/gdal
            contrib/libs/gdk-pixbuf
            contrib/libs/lcms2
            contrib/libs/libarchive
            contrib/libs/libde265
            contrib/libs/libc_compat
            contrib/libs/libevent
            contrib/libs/libheif
            contrib/libs/ffmpeg-3.4.1
            contrib/libs/libjpeg-turbo
            contrib/libs/libmemcached
            contrib/libs/libmysql_r/strings/uca9dump/bin
            contrib/libs/libpq
            contrib/libs/libpqxx
            contrib/libs/libraw
            contrib/libs/libx265
            contrib/libs/llvm12
            contrib/libs/llvm14
            contrib/libs/mecab
            contrib/libs/MoltenVK
            contrib/libs/nodejs_12
            contrib/libs/nsync
            contrib/libs/openssl
            contrib/libs/protobuf
            contrib/libs/protobuf_std
            contrib/libs/protoc
            contrib/libs/protoc_std
            contrib/libs/rocksdb
            contrib/libs/srt
            contrib/libs/t1ha
            contrib/libs/subversion/subversion/svn
            contrib/python
            contrib/restricted/abseil-cpp
            contrib/restricted/google/xnnpack
            contrib/restricted/cpuinfo
            contrib/restricted/libffi
            contrib/restricted/google/ruy
            contrib/restricted/spdlog
            contrib/restricted/thrift
            contrib/tests/compiler
            contrib/tests/protobuf
            contrib/tests/protobuf_std
            contrib/tools/ag
            contrib/tools/flatc
            contrib/tools/flatc64
            contrib/tools/grpc_cli
            contrib/tools/protoc
            contrib/tools/protoc_std
            contrib/tools/python
            contrib/tools/python3
            contrib/tools/ragel6
            contrib/tools/yasm

            kernel
            library
            util

            # Some generally useful projects
            catboost
            clickhouse
            kikimr/public/sdk/cpp
            kikimr/public/sdk/java
            kikimr/public/sdk/python
            kikimr/public/tools/ydb_recipe/examples
            kikimr/driver
            mapreduce/yt/python/recipe
            ydb/public/api
            ydb/public/lib
            yql/library/python
            yql/udfs/common
        )
    ELSE()
        RECURSE_ROOT_RELATIVE(
            alice/kronstadt
            alice/memento
            alice/paskills
            arc
            arcanum
            billing/hot
            catboost
            ci
            crypta/api
            devtools/distbuild
            devtools/ya
            devtools/ymake
            direct
            disk
            fintech
            iceberg/bolts
            iceberg/commune
            iceberg/commune-admin-all
            iceberg/commune-bazinga
            iceberg/commune-cassandra
            iceberg/commune-db
            iceberg/commune-dynproperties
            iceberg/commune-mail
            iceberg/commune-mongo3
            iceberg/commune-monica
            iceberg/commune-offheap
            iceberg/commune-uploader
            mail/payments
            market/billing
            market/cms
            market/infra/tsum
            market/infra/solomon-pusher-scheduler
            market/logistics
            market/market-tpl
            market/mbi
            market/mbo
            metrika
            music
            media-billing
            partner
            plus/mission_control
            solomon/libs
            sprav
            testenv
            yabs/rmp
            yabs/telephony
        )
    ENDIF()
ENDIF()

IF (OS_LINUX)
    IF (MUSL)
        RECURSE_ROOT_RELATIVE(
            adfox/amacs
            contrib/libs/musl
            contrib/libs/cxxsupp
            contrib/libs/libpqxx
            contrib/libs/subversion
            # we need tf libs explicitly to get its SRCS GLOBAL as results
            contrib/libs/tf-2.4
            contrib/libs/tf/all_ops
            contrib/libs/tf/minimal
            contrib/libs/tf/tensorflow/compiler
            contrib/tools/python
            util
            library/python
            library/cpp/testing/unittest/ut
            maps/libs/common
            maps/libs/geolib
            maps/libs/json
            maps/libs/s3mds
            maps/infra/ecstatic
            maps/infra/roquefort
            maps/infra/yacare

            # DEVTOOLSSUPPORT-4463
            search/daemons/begemot/default
            search/daemons/begemot/logger
            search/daemons/begemot/request_init
        )
    ELSEIF (COMMON_PROJECTS OR FAT_TESTS_COMMON)
        RECURSE_ROOT_RELATIVE(
            contrib
            kernel
            library
            util

            catboost

            mapreduce/yt/client
            mapreduce/yt/interface
            mapreduce/yt/python/recipe

            kikimr/public/sdk/cpp
            kikimr/public/sdk/java
            kikimr/public/sdk/python
            kikimr/public/tools/ydb_recipe/examples

            # we need tf libs explicitly to get its SRCS GLOBAL as results
            contrib/libs/tf-2.4
            contrib/libs/tf/all_ops
            contrib/libs/tf/minimal
            contrib/libs/tf/tensorflow/compiler

            logbroker/public/api/grpc
            logbroker/public/api/protos

            sandbox/common
            sandbox/projects/common

            scarab/api

            ydb/public/api
            ydb/public/lib
            yql/library/python
            yql/udfs/common
        )
        IF (FAT_TESTS_COMMON)
            RECURSE_ROOT_RELATIVE(
                scarab/api
            )
        ENDIF()
    ELSEIF (FAT_TESTS_PROJECTS)
        RECURSE_ROOT_RELATIVE(
            catboost
            cloud/blockstore/libs
            devtools/ya
            dj/lib
            infra/yp_service_discovery
            ydb/core

            logbroker/unified_agent/client/cpp
            logbroker/unified_agent/client/python
            logbroker/unified_agent/common/grpc
            logbroker/unified_agent/common/util
            logbroker/unified_agent/plugins/grpc_input/proto

            quality/antifraud
            robot

            rtmapreduce/libs
            rtmapreduce/protos

            scarab/api

            yabs/server
            yt

            yweb/antispam
            yweb/robot
        )
    ELSEIF (FAT_TESTS_RELWITHDEBINFO)
        RECURSE_ROOT_RELATIVE(
            devtools/ya
            devtools/ymake

            yweb/news

            yt
        )
    ELSEIF (JDK_VERSION == "15")
        INCLUDE(${ARCADIA_ROOT}/autocheck/linux/jdk15_targets.inc)
        RECURSE_ROOT_RELATIVE(${AUTOCHECK_JDK15_TARGETS})
    ELSEIF (JDK_VERSION == "16")
        INCLUDE(${ARCADIA_ROOT}/autocheck/linux/jdk16_targets.inc)
        RECURSE_ROOT_RELATIVE(${AUTOCHECK_JDK16_TARGETS})
    ELSEIF (TENSORFLOW_WITH_CUDA)
        RECURSE_ROOT_RELATIVE(
            # we need tf libs explicitly to get its SRCS GLOBAL as results
            contrib/libs/tf
            contrib/libs/tf-2.4
            contrib/libs/tf/all_ops
            contrib/libs/tf/minimal
            contrib/libs/tf/tensorflow/compiler
        )
    ELSEIF(MOST_USED_CUDA)
        RECURSE_ROOT_RELATIVE(
            voicetech/asr/engine/bin
            voicetech/ars/server
            voicetech/asr/nn_server/bin/nn_server
        )
    ELSE()
        PARTITIONED_RECURSE_ROOT_RELATIVE(
            BALANCING_CONFIG autocheck/balancing_configs/cache-heater.json
            ads/bsyeti
            ads/quality/adv_machine
            alice/bass
            alice/kronstadt
            alice/megamind
            alice/memento
            alice/paskills
            alice/hollywood
            alice/uniproxy
            alice/vins
            arc
            arcanum
            billing/hot
            catboost
            ci
            crypta
            devtools/distbuild
            devtools/ya
            devtools/ymake
            dict/misspell
            dict/mt
            dict/ontodb
            direct
            dj
            entity
            fintech
            iceberg/bolts
            iceberg/commune
            iceberg/commune-admin-all
            iceberg/commune-bazinga
            iceberg/commune-cassandra
            iceberg/commune-db
            iceberg/commune-dynproperties
            iceberg/commune-mail
            iceberg/commune-mongo3
            iceberg/commune-monica
            iceberg/commune-offheap
            iceberg/commune-uploader
            intranet
            infra/deploy_export_stats
            infra/deploy_logs_validation
            infra/deploy_monitoring_controller
            infra/deploy_notifications_controller
            infra/deploy_queue_controller
            infra/deploy_sbr_updater
            infra/deploy_sidecars_updater
            jupytercloud/arcadia_kernel
            kikimr/driver
            logos
            mail/payments
            mapreduce/yt/client
            mapreduce/yt/interface
            maps/analyzer
            maps/jams
            maps/libs/common
            maps/libs/geolib
            maps/libs/json
            maps/masstransit
            maps/renderer
            maps/routing
            maps/infra/ratelimiter2
            maps/infra/yacare
            market/billing
            market/cms
            market/idx
            market/infra/tsum
            market/infra/solomon-pusher-scheduler
            market/logistics
            market/market-tpl
            market/mbi
            market/mbo
            market/report
            media/radiojam
            metrika
            music
            media-billing
            partner
            plus/mission_control
            quality/antifraud/libs
            quality/antifraud/py_libs
            quality/antifraud/xurma/core
            quality/antifraud/xurma/fury
            quality/antifraud/xurma/tools
            quality/neural_net
            quality/nirvana_tools/conveyor_operations/train_dssm
            quality/relev_tools/matrixnet
            robot/addurl
            robot/jupiter
            robot/lemur
            robot/metrics
            robot/mercury/test
            robot/rthub/main
            robot/rthub/yql/udfs
            robot/samovar
            solomon/libs
            saas/rtyserver
            saas/rtyserver_jupi
            saas/rtyserver_test
            sandbox/tasks/tests/bin
            scarab/api/cpp
            search/daemons
            search/panther/tools/idx_convert
            search/web/rearrs_upper/tests/rearrange.fast
            sprav
            testenv
            voicetech/asr
            wmconsole/backend
            yabs/rmp
            yabs/server/cs/package
            yabs/server/packages/cloud
            yabs/server/test
            yabs/server/tools
            yabs/telephony
            yabs/utils/yabs-stat-tools
            yp
            yql/library/embedded/python
            yql/library/python
            yt
            yt/packages/latest
            yweb/antimalware/visual_html_parser/directchecker
            yweb/antispam/clean_web
            yweb/robot/limbo
            yweb/robot/ukrop
        )
    ENDIF()
ENDIF()
