OWNER(g:yatool)

INCLUDE(${ARCADIA_ROOT}/autocheck/common_targets.inc)

SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
    ${AUTOCHECK_COMMON_TARGETS}
)

SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
    voicetech/spotter/embedded/programs/spottest
)

IF (ARCH_I686)
    SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
        dict/misspell/spellchecker/offline
        contrib/libs/opencv
        speechkit
    )
    IF (CLANG_CL)
        # tflite (used by text_classifier) doesn't build with msvc-i686 compiler due to internal compiler error
        SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
            cv/imageproc/ocr/api/text_classifier
        )
    ENDIF()
ELSE()
    SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
        ads/quality/simulate_auction
        arc/local
        browser/infra/library
        catboost
        cloud/marketplace/agent
        contrib/go
        contrib/libs/ImageMagick
        contrib/libs/apache
        contrib/libs/aws-sdk-cpp/aws-cpp-sdk-core
        contrib/libs/bdb
        contrib/libs/blake2
        contrib/libs/c-ares
        contrib/libs/cairo
        contrib/libs/cctz
        contrib/libs/ctemplate
        contrib/libs/curl
        contrib/libs/dokany/dokan
        contrib/libs/dokany/dokan_fuse
        contrib/libs/fastops
        contrib/libs/gdal
        contrib/libs/gdk-pixbuf
        contrib/libs/geos
        contrib/libs/giflib
        contrib/libs/harfbuzz
        contrib/libs/icu
        contrib/libs/jemalloc
        contrib/libs/lcms2
        contrib/libs/libarchive
        contrib/libs/libde265
        contrib/libs/libevent
        contrib/libs/libheif
        contrib/libs/libiconv
        contrib/libs/libidn
        contrib/libs/libidn2
        contrib/libs/libjpeg-turbo
        contrib/libs/libmysql_r
        contrib/libs/libmysql_r/strings/uca9dump/bin
        contrib/libs/libogg
        contrib/libs/libpng
        contrib/libs/libpq
        contrib/libs/libpqxx
        contrib/libs/libraw
        contrib/libs/librsvg
        contrib/libs/libunistring
        contrib/libs/libvpx
        contrib/libs/libx265
        contrib/libs/llvm12
        contrib/libs/llvm14
        contrib/libs/mecab
        contrib/libs/minizip
        contrib/libs/mozjpeg
        contrib/libs/opencv
        contrib/libs/openjpeg
        contrib/libs/opus
        contrib/libs/pixman
        contrib/libs/postgresql
        contrib/libs/proj
        contrib/libs/protoc
        contrib/libs/protoc_std
        contrib/libs/rocksdb
        contrib/libs/speex
        contrib/libs/sqlite3
        contrib/libs/subversion
        contrib/libs/tf/tensorflow/lite
        contrib/libs/tlsh
        contrib/libs/webrtc
        contrib/libs/zlib
        contrib/python/MySQL-python
        contrib/python/ipython
        contrib/python/mypy-protobuf/bin/protoc-gen-mypy/bin
        contrib/python/pycrypto
        contrib/restricted/abseil-cpp
        contrib/restricted/glib
        contrib/restricted/googletest/googlemock
        contrib/restricted/googletest/googletest
        contrib/restricted/http-parser
        contrib/restricted/thrift
        contrib/restricted/uriparser
        contrib/tests/subvertpy
        contrib/tools/bison
        contrib/tools/flatc/bin
        contrib/tools/flatc64/bin
        contrib/tools/gperf
        contrib/tools/grpc_cli
        contrib/tools/protoc/bin
        contrib/tools/protoc/plugins/cpp_styleguide/bin
        contrib/tools/protoc/plugins/grpc_cpp/bin
        contrib/tools/protoc/plugins/grpc_java/bin
        contrib/tools/protoc/plugins/grpc_python/bin
        contrib/tools/protoc_std
        contrib/tools/python
        contrib/tools/python/bootstrap/bin
        contrib/tools/python3/pycc/bin
        contrib/tools/ragel5
        contrib/tools/ragel6/bin
        contrib/tools/watchman
        contrib/tools/yasm/bin
        cv/imageproc/ocr/api/text_classifier
        devtools/codenav/yndexer
        devtools/dummy_arcadia/bugs
        devtools/dummy_arcadia/includes
        devtools/dummy_arcadia/llvm_ir
        devtools/dummy_arcadia/models
        devtools/dummy_arcadia/py_googleapis
        devtools/executor
        devtools/ya/bin
        devtools/ya/bin/small
        devtools/ya/test/programs
        devtools/ymake
        dict/dictutil
        dict/misspell
        dict/mt/daemon
        dict/mt/libs
        dict/mystem
        dict/mystem/tests
        dict/predict
        geobase/library
        geosuggest/daemons/geosuggestd
        kernel
        kikimr/driver
        kikimr/public/tools/ydb
        library
        mail/java/pglocal
        maps/libs
        maps/renderer
        market/erp_axapta/logbroker_reader
        passport
        quality/factors/lingboost/allex/sanitizer_tests
        quality/relev_tools/knn/lib
        quality/relev_tools/knn/lib/hnsw_graph
        quality/relev_tools/lboost_ops/inmem_bench/exec_run
        quality/relev_tools/matrixnet
        quality/relev_tools/mx_ops
        quality/relev_tools/mx_ops/build_tool
        quality/relev_tools/mx_ops/lib
        quality/relev_tools/mx_ops/tests
        quality/ytlib/ytweave/ut
        security/skotty
        security/tools/goat
        security/yadi/yadi
        security/yadi/yadi-arc
        solomon/sysmon
        speechkit
        statbox/bindings/signurl/pymodule
        statbox/bindings/tdigest/pymodule
        statbox/libstatbox/python/pymodule
        statbox/nile/pymodules
        statbox/qb2_core/pymodules
        statbox/ydl
        tools/enum_parser/enum_parser/bin
        tools/event2cpp/bin
        tools/fix_elf/bin
        tools/go_fake_xcrun
        tools/go_test_miner
        tools/printtrie
        tools/rescompiler/bin
        tools/rescompressor/bin
        tools/rorescompiler/bin
        tools/triecompiler
        tools/trietest
        unified_agent
        util/system/ut
        vcs/hg/client
        vendor
        ydb/public/api
        yql
    )

    IF (CLANG_CL)
        SET_APPEND(AUTOCHECK_WINDOWS_TARGETS
            ads/yacontext/lib/dssm/inference/lib
        )
    ENDIF()
ENDIF()

PARTITIONED_RECURSE_ROOT_RELATIVE(
    ${AUTOCHECK_WINDOWS_TARGETS}
)
